<?php

/*
        ----
        oDns  -  A php4/perl/mysql frontend for the BIND name server 
        ----

        * Copyright (C) 2000  Olivier Mueller <om@omnis.ch>

        $Id: index.php,v 1.3 2000/08/17 22:14:25 swix Exp $
        $Source: /cvsroot/oDns/odns/index.php,v $

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.
  
        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
	
	// initialization	

	include("config.php");
	include("odns_htmlstuff.php");
	include("odns_sql_stuff.php");
	include("odns_domain_form.php");
	include("odns_slave_form.php");
	include("odns_host_form.php");
	include("odns_contact_form.php");
	db_connect();

	// by default, domain owner is admin 
	$owner_id = 0;

	// auth
	require("odns_auth.php");	// -> setup $lang

	// switch on action
	if (!$action || $action == "login") { 
		
		html_head("oDns Entry page - User ID $owner_id");
		?>
<div><h2>oDns <?php echo($version); ?> - [ User ID: <?php echo($owner_id); if ($owner_id == 0) { echo("  (Root)"); } ?> ]</h2></div>
<div>Welcome to the <I>oDns</I> Project. This is a php/perl/mysql frontend for the BIND 8.2.1 an higher Name Server. </div>
<div>All the hosts informations are saved in four sql tables (dns_domains, dns_hosts, dns_entries and dns_contacts : </div>
<div> see <a href="mysqldump.txt">mysqldump.txt</a> for the structure). </div>
<br><div>PHP is used for this front end which allows to : <ul>
<li>add/edit/remove primary domains
<li>add/remove slave domains
<li>add/edit/remove contact information sheets
</ul></div>
<div>In the background, Perl is used to generate standard <b>named.conf</b> and the specific
zone files for all the primary domains</div>
<br><div>You can test the program on this page. If you have comments, questions and suggestions, feel free to mail 
me at <a href="mailto:om@omnis.ch"> om@omnis.ch</a>. <br>Last update: $Id: index.php,v 1.3 2000/08/17 22:14:25 swix Exp $ </div>
<br><div>To update the <B>zone files</B> and <B>named.conf</B>, please run <B><a href="odns.pl">odns.pl</a></B>. The files
can be the browsed in this <a href="zones">directory</a>.</div>


	 	<?php

	// little hack, but it should be ok
	// (let root have access to all domains)
	
	if ($owner_id == 0) { $owner_id = "%"; }


	print "<table>";
	print "<tr><td colspan=2><br><hr noshade><br><br></td></tr>";
	print "<tr><td valign=top>";

		// PRIMARY
		// select list with new / edit / delete button
	
		$sql_query = "SELECT domain FROM $tb_dns_domains WHERE type LIKE 'primary' AND owner_id LIKE '$owner_id' ORDER by domain";
		$sql_result = mysql_query($sql_query);
		$sql_row_count = mysql_num_rows($sql_result);		

		print "<form action=\"$PHP_SELF\" method=\"GET\">";
		print "<table bgcolor=\"lightblue\">";
		print "<tr><td width=\"100%\" colspan=\"2\" bgcolor=\"#000000\"><font size=\"-2\" color=\"#FFFFFF\">";
		print "<b>Manage Primary Domains : <b>$sql_row_count</b> entries in database</b></font></td></tr>";

		if ($sql_row_count) {

			print "<tr><td colspan=2>Domain: ";
			print "<select name=\"domain\">";
					
			while ($sql_row = mysql_fetch_row($sql_result)) {
				print "<option>" . $sql_row[0] . "</option>";
			}
	
			print "</select></td></tr>";
			print "<tr><td>To edit the selected domain</td><td align=\"center\" width=\"25%\">";
			print "<input type=\"submit\" name=\"action\" value=\"Edit\">";
			print "</td></tr><tr><td>To remove the selected domain</td><td align=\"center\" width=\"25%\">";
			print "<input type=\"submit\" name=\"action\" value=\"Delete\"></td></tr>";
			print "<tr><td>To create a new zone using the selected domain as template</td><td align=\"center\" width=\"25%\">";
			print "<input type=\"submit\" name=\"action\" value=\"New\"></td></tr>";
		} 

		print "<tr><td>To create a new zone with a blank template</td><td align=\"center\" width=\"25%\">";
		print "<input type=\"submit\" name=\"action\" value=\"New Blank\">";
		print "</td></tr></table>";
		print "</form>";
	
		
	print "</td><td valign=top>";


		// SECONDARY
		// select list with new / edit / delete button
	
		$sql_query = "SELECT domain FROM $tb_dns_domains WHERE type LIKE 'slave' AND owner_id LIKE '$owner_id' ORDER BY domain";
		$sql_result = mysql_query($sql_query);
		$sql_row_count = mysql_num_rows($sql_result);		


		print "<form action=\"$PHP_SELF\" method=\"GET\">";
		print "<table bgcolor=\"lightblue\">";
		print "<tr><td width=\"100%\" colspan=\"2\" bgcolor=\"#000000\"><font size=\"-2\" color=\"#FFFFFF\">";
		print "<b>Manage Slave Domains : <b>$sql_row_count</b> entries in database</b></font></td></tr>";

		if ($sql_row_count) {

			print "<tr><td colspan=2>Domain: ";
			print "<select name=\"domain\">";
				
			while ($sql_row = mysql_fetch_row($sql_result)) {
				print "<option>" . $sql_row[0] . "</option>";
			}
		
			print "</select></td></tr>";
			print "<tr><td>To edit the selected domain</td><td align=\"center\" width=\"25%\">";
			print "<input type=\"submit\" name=\"action\" value=\"Edit Slave\">";
			print "</td></tr><tr><td>To remove the selected slave</td><td align=\"center\" width=\"25%\">";
			print "<input type=\"submit\" name=\"action\" value=\"Delete Slave\"></td></tr>";
		}

		print "<tr><td>To create a new zone</td><td align=\"center\" width=\"25%\">";
		print "<input type=\"submit\" name=\"action\" value=\"New Slave\">";
		print "</td></tr></table>";
		print "</form>";

	print "</td></tr><tr><td colspan=2><br><hr noshade><br><br></td></tr><tr><td valign=top align=center>";


		// HOSTS
		// select list with new / edit / delete button
	
		$sql_query = "SELECT host_id FROM $tb_dns_hosts WHERE owner_id LIKE '$owner_id' ORDER by host_id";
		$sql_result = mysql_query($sql_query);
		$sql_row_count = mysql_num_rows($sql_result);		


		print "<form action=\"$PHP_SELF\" method=\"GET\">";
		print "<table bgcolor=\"lightblue\">";
		print "<tr><td width=\"100%\" colspan=\"2\" bgcolor=\"#000000\"><font size=\"-2\" color=\"#FFFFFF\">";
		print "<b>Manage Hosts List : <b>$sql_row_count</b> entries in database</b>";
		print "<br>-> these hosts can be then used by editing Primary domain";
		print "</font></td></tr>";

		if ($sql_row_count) {

			print "<tr><td colspan=2>Hostname: ";
			print "<select name=\"hostname\">";
				
			while ($sql_row = mysql_fetch_row($sql_result)) {
				print "<option>" . $sql_row[0] . "</option>";
			}
		
			print "</select></td></tr>";
			print "<tr><td>To edit the selected host</td><td align=\"center\" width=\"25%\">";
			print "<input type=\"submit\" name=\"action\" value=\"Edit Host\">";
			print "</td></tr><tr><td>To remove the selected host</td><td align=\"center\" width=\"25%\">";
			print "<input type=\"submit\" name=\"action\" value=\"Delete Host\"></td></tr>";
		}

		print "<tr><td>To create a new host</td><td align=\"center\" width=\"25%\">";
		print "<input type=\"submit\" name=\"action\" value=\"New Host\">";
		print "</td></tr></table>";
		print "</form>";

	print "</td><td valign=top>";


		// CONTACTS
		// select list with new / edit / delete button
	
		$sql_query = "SELECT contact_name FROM $tb_dns_contacts WHERE owner_id LIKE '$owner_id' ORDER BY contact_name";
		$sql_result = mysql_query($sql_query);
		$sql_row_count = mysql_num_rows($sql_result);		


		print "<form action=\"$PHP_SELF\" method=\"GET\">";
		print "<table bgcolor=\"lightblue\">";
		print "<tr><td width=\"100%\" colspan=\"2\" bgcolor=\"#000000\"><font size=\"-2\" color=\"#FFFFFF\">";
		print "<b>Manage Contacts List : <b>$sql_row_count</b> entries in database</b>";
		print "<br>-> Also for the Primary template. Goal: be able to<br>send domain registration request to switch using email";
		print "</font></td></tr>";

		if ($sql_row_count) {

			print "<tr><td colspan=2>Contact ID: ";
			print "<select name=\"contactid\">";
				
			while ($sql_row = mysql_fetch_row($sql_result)) {
				print "<option>" . $sql_row[0] . "</option>";
			}
		
			print "</select></td></tr>";
			print "<tr><td>To edit the selected contact</td><td align=\"center\" width=\"25%\">";
			print "<input type=\"submit\" name=\"action\" value=\"Edit Contact\">";
			print "</td></tr><tr><td>To remove the selected contact</td><td align=\"center\" width=\"25%\">";
			print "<input type=\"submit\" name=\"action\" value=\"Delete Contact\"></td></tr>";
		}

		print "<tr><td>To create a contact sheet</td><td align=\"center\" width=\"25%\">";
		print "<input type=\"submit\" name=\"action\" value=\"New Contact\">";
		print "</td></tr></table>";
		print "</form>";

	print "</td></tr><tr><td colspan=2><br><hr noshade><br><br></td></tr>";

	print "<tr><td colspan=2 align=center>";
	auth_again_box("End session","Logout",$PHP_SELF);
	print "</td></tr></table>";

		html_end();
	}		


	// PRIMARY DOMAIN ACTIONS 

	if ($action == "New") {

		check_ownership("domain", $domain);

		// show form with Domain Name Input form active
		html_head("oDns Create zone page");

    		    display_dns_form($domain, "new");

		html_end();

	}	

	if ($action == "New Blank") {
		// show form with Domain Name Input form active
		html_head("oDns Create zone page");
		display_dns_form("", "new_blank");
		html_end();
	}	


	if ($action == "Edit") {

		check_ownership("domain", $domain);
	
		// show form without allowing a domain name change 
		// (encode domain name in form)
		html_head("oDns Edit zone page");

			display_dns_form($domain, "edit");
		
		html_end();
	}


	if ($action == "Delete") {

		check_ownership("domain", $domain);
	
		html_head("oDns Delete zone page");
	
		// ask for confirmation

		// delete entry from dns_domains
			delete_domain_entries($tb_dns_domains, $domain);		
		// delete entries from dns_entries
			delete_domain_entries($tb_dns_entries, $domain);

 		   	info_box("Primary domain $domain deleted.", $PHP_SELF);

		html_end();
	}


	// SLAVE DOMAIN ACTIONS

	if ($action == "New Slave") {
		// show form with Domain Name Input form active
		html_head("oDns Creatie slave page");
		display_slave_form("", "new_blank");
		html_end();
	}	


	if ($action == "Edit Slave") {

		check_ownership("domain", $domain);

		// show form without allowing a domain name change 
		// (encode domain name in form)
		html_head("oDns Edit slave page");

			display_slave_form($domain, "edit");

		html_end();
	}


	if ($action == "Delete Slave") {

		check_ownership("domain", $domain);

		html_head("oDns Delete slave page");
	
        		// ask for confirmation

			// delete entry from dns_domains
			delete_domain_entries($tb_dns_domains, $domain);		
			info_box("Slave domain $domain deleted.", $PHP_SELF);

		html_end();
 	}


	// HOSTS ACTIONS

	if ($action == "New Host") {
		// show form with Domain Name Input form active
		html_head("oDns Create host page");
		display_host_form("", "new_blank");
		html_end();
	}	


	if ($action == "Edit Host") {

		check_ownership("host", $hostname);

		// show form without allowing a domain name change 
		// (encode domain name in form)
		html_head("oDns Edit host page");

		    display_host_form($hostname, "edit");
		
		html_end();
	}


	if ($action == "Delete Host") {

		check_ownership("host", $hostname);

		html_head("oDns Delete host page");

		    // ask for confirmation
		    // check if host used in dns_entries -> reject 
		    check_if_in_use("host", $hostname);

		    // delete entry from dns_hosts

		    delete_host_entry($hostname);	
		    	
		    info_box("Host $hostname deleted.", $PHP_SELF);
		
		html_end();
 	}


	// CONTACT ACTIONS

	if ($action == "New Contact") {
		// show form with Domain Name Input form active
		html_head("oDns Create contact page");
		display_contact_form("", "new_blank");
		html_end();
	}	


	if ($action == "Edit Contact") {

	    check_ownership("contact", $contactid);

		// show form without allowing a domain name change 
		// (encode domain name in form)
		html_head("oDns Edit contact page");

		    display_contact_form($contactid, "edit");

		html_end();
	}


	if ($action == "Delete Contact") {

		check_ownership("contact", $contactid);
		html_head("oDns Delete contact page");
		
		// ask for confirmation
		// 	first check if contact not used anywhere, then
		check_if_in_use("contact", $contactid);

		delete_contact_entry($contactid);		

		info_box("Contact $contactid deleted.", $PHP_SELF);
 	
	
		html_end();
	
	}	
	



	// PARSE ACTIONS



	if ($action == "parse_host_form") {
	
	html_head("oDns Save");

		if (!$host_id) { 
			info_box("Error: Host ID empty...", $PHP_SELF);
			die(); 
		}

	$sql_query = "SELECT host_id FROM $tb_dns_hosts WHERE host_id LIKE '$host_id'";
	$sql_result = mysql_query($sql_query);

	if (mysql_num_rows($sql_result)) { 

	    check_ownership("host",$host_id);

		// if yes -> update
		
		$sql_query = "UPDATE $tb_dns_hosts SET host='$host'".
			" WHERE host_id LIKE '$host_id'";
		$sql_result = mysql_query($sql_query);

	} else {

		// if not -> insert
	
		$sql_query="INSERT INTO $tb_dns_hosts (owner_id,host_id,host,creation_date) VALUES " .
		"('$owner_id','$host_id', '$host', NOW())";
		$sql_result=mysql_query($sql_query);
	}

		info_box("Data saved for host $host_id.", $PHP_SELF);
	}




	if ($action == "parse_contact_form") {

		html_head("oDns Save");

		if (!$contact_name) { 
			info_box("Error: Contact ID empty...", $PHP_SELF);
			die(); 
		}


	$sql_query = "SELECT contact_name FROM $tb_dns_contacts WHERE contact_name LIKE '$contact_name'";
	$sql_result = mysql_query($sql_query);

	if (mysql_num_rows($sql_result)) { 

	    check_ownership("contact", $contact_name);
	
		// if yes -> update
		
		$sql_query = "UPDATE $tb_dns_contacts SET ".
			"org='$org',".
			"name='$name',".
			"address1='$address1',".
			"address2='$address2',".
			"zipcode='$zipcode',".
			"city='$city',".
			"country='$country',".
			"phone='$phone',".
			"fax='$fax',".
			"email='$email'".
			" WHERE contact_name LIKE '$contact_name'";
		$sql_result = mysql_query($sql_query);

	} else {

		// if not -> insert
	    
		$contact_name = strtoupper($contact_name);
		$sql_query="INSERT INTO $tb_dns_contacts ".
			"(owner_id,contact_name,org,name,address1,address2,zipcode,city,country,phone,fax,email,creation_date) VALUES " .
		"('$owner_id','$contact_name','$org','$name','$address1','$address2','$zipcode','$city','$country','$phone','$fax','$email', NOW())";
		$sql_result=mysql_query($sql_query);
	}

		info_box("Data saved for contact $contact_name", $PHP_SELF);
	}




	if ($action == "parse_slave_form") {

		html_head("oDns Slave Save");

		if ($id) { 
		    $domain = base64_decode($id);
		    check_ownership("domain",$domain); 
		} else {
		    check_if_exists("domain",$domain);
		}
			
		if (!$domain) { 
			info_box("Error: Domain name empty...", $PHP_SELF);
			die(); 
		}
			
		if ($primary == "-1" || !$primary) { 
			info_box("Error: Please choose a primary server!", $PHP_SELF);
			die(); 
		}

		if ($owner_id == 0 && $entry_owner_id) { $tmp_owner_id = $entry_owner_id; }
		    else { $tmp_owner_id = $owner_id; }

		update_domain_list($tb_dns_domains, $domain, "slave", $primary, $tmp_owner_id);
		info_box("Slave Domain $domain saved.", $PHP_SELF);

	}





	if ($action == "parse_primary_form") {

		html_head("oDns Entry page");

		// findout domain name 
		if ($id) { 
			$domain = base64_decode($id); 
			check_ownership("domain", $domain);
			$new = 0;
			$A_entries_host = load_data_array($tb_dns_entries, "var_name", "host_id", "WHERE host_id NOT LIKE '' AND domain LIKE '$domain'");
			$A_entries_var = load_data_array($tb_dns_entries, "var_name", "var_content", "WHERE var_content NOT LIKE '' AND domain LIKE '$domain'");
		} else  { 
			check_if_exists("domain",$domain);
			$new = 1; 
		}	

		// stop if no domain name
		if (!$domain) { 
			info_box("Error: Domain name empty...", $PHP_SELF);
			die(); 
		}


		// check if minimal data here (dns1)
		// (TODO)

		// update dns_domains
    
		if ($owner_id == 0 && $entry_owner_id) { $tmp_owner_id = $entry_owner_id; }
		    else { $tmp_owner_id = $owner_id; }
		    
		update_domain_list($tb_dns_domains, $domain, "primary", "", $tmp_owner_id);

		if ($host_soa_ns1) {
			$primary_dns = $host_soa_ns1;
		} elseif ($var_soa_ns1) {
			$primary_dns = $var_soa_ns1;
		} 

		// check if secondary name server changed. if yes :
		//  1. check if old server is registred in dns_servers
		//  2. if yes, delete from remote server (otherwise -> puff :)
		// then check if new ns server is registred in dns_server. if yes, anounce on server.

		for($i=2; $i<=4; $i++) {
				
                       	$ref_host_id = "host_soa_ns$i";
                       	$ref_var_content = "var_soa_ns$i";

			// delete old things if necessary.

			if ($$ref_var_content != $A_entries_var["soa_ns$i"] && $A_entries_var["soa_ns$i"]) {
				delete_remote_domain($domain, $A_entries_var["soa_ns$i"]);
			}		

			if ($$ref_var_content != $A_entries_var["soa_ns$i"] && $A_entries_host["soa_ns$i"]) {
				delete_remote_domain($domain, $A_entries_host["soa_ns$i"]);
			}		

			if ($$ref_host_id != $A_entries_host["soa_ns$i"] && $A_entries_host["soa_ns$i"]) {
				delete_remote_domain($domain, $A_entries_host["soa_ns$i"]);
			}


			// announce domain on secondary servers if they are using odns too

			if ($$ref_var_content) {
				add_remote_domain($domain, $primary_dns, $$ref_var_content);
			} elseif ($$ref_host_id) {
				add_remote_domain($domain, $primary_dns, $$ref_host_id);
			} 

		}

				

		// delete all old entries for this domain from dns_entries
		delete_domain_entries($tb_dns_entries, $domain);

		// save form data to dns_entries:

		// Standard SOA variables		

		insert_domain_entries($tb_dns_entries, $domain, "soa_serial", $soa_serial, "");
		insert_domain_entries($tb_dns_entries, $domain, "soa_refresh", $soa_refresh, "");	
		insert_domain_entries($tb_dns_entries, $domain, "soa_retry", $soa_retry, "");	
		insert_domain_entries($tb_dns_entries, $domain, "soa_expire", $soa_expire, "");	
		insert_domain_entries($tb_dns_entries, $domain, "soa_ttl", $soa_ttl, "");	

		// NS & MX

		$soavars[] = "ns1";		$soavars[] = "ns2";		$soavars[] = "ns3";
		$soavars[] = "ns4";		$soavars[] = "mx1";		$soavars[] = "mx2";
		$soavars[] = "nic_bil";	$soavars[] = "nic_adm";	$soavars[] = "nic_tec";

		reset($soavars);
			while(list ($int3,$tmp3) = each ($soavars) ) {

			$var_name = "soa_$tmp3";

			$ref_host_id = "host_soa_$tmp3";
			$ref_var_content = "var_soa_$tmp3";

			if ($$ref_var_content) {
				insert_domain_entries($tb_dns_entries, $domain, $var_name, $$ref_var_content, "");	
			} elseif ($$ref_host_id) {
				insert_domain_entries($tb_dns_entries, $domain, $var_name, "", $$ref_host_id);	
			} 
		}


		// Other vars (with $label_ , $host_ and $var_)

		reset($HTTP_GET_VARS);

			// problem: var_name is hash index on the form, but there are cases where there are
			// multiple entries with same var_name : mx1 and mx2, or round robin entries.
			// let's try to make this work with a kind of trick for the moment : add some 
			// invisible "_" in the front of the variable.
			
			// $trick1 = "";
			while(list ($int,$tmp) = each ($HTTP_POST_VARS) ) {
		
			if ( ereg("label_a_cname", $int) ) {

				$varname = substr($int, 14);

				$ref_var_name = $$int;
				$ref_host_id = "host_$varname";
				$ref_var_content = "var_$varname";

				if ($$ref_var_content) {
					insert_domain_entries($tb_dns_entries, $domain, $ref_var_name, $$ref_var_content, "", "a_cname");	
				} elseif ($$ref_host_id) {
					insert_domain_entries($tb_dns_entries, $domain, $ref_var_name, "", $$ref_host_id, "a_cname");	
				} 				
			}				


			if ( ereg("label_mx", $int) ) {

				$varname = substr($int, 9);

				$ref_var_name = $$int;
				if ($ref_var_name == "ZONEDOMAIN") { $ref_var_name = $domain; }
				$ref_host_id = "mx_host_$varname";
				$ref_var_content = "mx_var_$varname";
				$ref_mx_pref = "mx_pref_$varname";

				if ($$ref_var_content) {
					insert_domain_entries($tb_dns_entries, $domain, $ref_var_name, $$ref_var_content, "", "mx", $$ref_mx_pref);	
				} elseif ($$ref_host_id) {
					insert_domain_entries($tb_dns_entries, $domain, $ref_var_name, "", $$ref_host_id, "mx", $$ref_mx_pref);	

				}				
				// $trick1 .= "_";				
			}				


		}



		// The short-www stuff (http://domain.ext == http://www.domain.ext)

		if ($www_short && $host_www) {
			insert_domain_entries($tb_dns_entries, $domain, $domain, "", $host_www, "a_cname");	
		} elseif ($www_short && $var_www) {
			insert_domain_entries($tb_dns_entries, $domain, $domain, $var_www, "", "a_cname");	
		}


		// Finished!
	
		if ($caller) {
		info_box("Primary Domain $domain updated", $$caller);
		} else {
		info_box("Primary Domain $domain updated", $PHP_SELF);
		}
		html_end();
	
	}


	exit();



/*
    If A equals success, then the formula is A = X + Y + Z.  
    X is work.  Y is play.  Z is keep your mouth shut.
                -- Albert Einstein
							       */
?>
