#!/usr/bin/perl 
#
#        ----
#        oDns  -  A php4/perl/mysql frontend for the BIND name server 
#        ----
#
#        * Copyright (C) 2000  Olivier Mueller <om@omnis.ch>
#
#        $Id: odns.pl,v 1.3 2000/08/17 22:14:25 swix Exp $
#        $Source: /cvsroot/oDns/odns/odns.pl,v $
#
#        This program is free software; you can redistribute it and/or modify
#        it under the terms of the GNU General Public License as published by
#        the Free Software Foundation; either version 2 of the License, or
#        (at your option) any later version.
#
#        This program is distributed in the hope that it will be useful,
#        but WITHOUT ANY WARRANTY; without even the implied warranty of
#        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#        GNU General Public License for more details.
#  
#        You should have received a copy of the GNU General Public License
#        along with this program; if not, write to the Free Software
#        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####################################################################

print "Content-type: text/html\n\n";
print "oDns.pl output:\n<pre>";

# locad DBI module
use DBI;

# init variables & paths

require "config.pl";
$date = localtime;

# open connection to the database;
$db = DBI->connect("DBI:mysql:$database_name:localhost",$admin_login,$admin_passwd)
        or die "mysql connection failed";


# get latest timestamp from domains database :

$last_ts = $db->prepare("select timestamp from $dns_domains order by timestamp desc limit 0,1");
$last_ts->execute or die "ts query error"; 
$last_ts_big = ($last_ts->fetchrow_array)[0];
print "domains - ts1: $last_ts_big\n";

# get latest timestamp from hosts database :

$last_ts2 = $db->prepare("select ts from $dns_hosts order by ts desc limit 0,1");
$last_ts2->execute or die "ts2 query error"; 
$last_ts_big2 = ($last_ts2->fetchrow_array)[0];
print "  hosts - ts2: $last_ts_big2\n";

# get latest timestamp from entries database :

$last_ts3 = $db->prepare("select ts from $dns_entries where var_name not like 'soa_serial' order by ts desc limit 0,1");
$last_ts3->execute or die "ts3 query error"; 
$last_ts_big3 = ($last_ts3->fetchrow_array)[0];
print "entries - ts3: $last_ts_big3\n";

if ($last_ts_big < $last_ts_big2) { $last_ts_big = $last_ts_big2; }
if ($last_ts_big < $last_ts_big3) { $last_ts_big = $last_ts_big3; }

$last_ts = substr($last_ts_big,0,8);
print "\nlast : $last_ts_big\n";


if (open(LASTCHANGE, $named_lastchange)) {

	print "hello...\n";
	$lastgen = <LASTCHANGE>;
	chomp $lastgen;
	chomp $last_ts_big;
	close(LASTCHANGE);
	if ($lastgen >= $last_ts_big && $ARGV[0] ne "force" &&  $ARGV[0] ne "--force" ) {
		print "SKIP. last gen : $lastgen - last in db : $last_ts_big\n";
		print "(no changes in database since last generation)\n";
		print "(use the --force option if you want to generate anyway)\n";
		exit(0);
	} else {
		print "GENERATE. last gen : $lastgen - last in db : $last_ts_big\n";
	}		
}

if (open(LWRITE, ">$named_lastchange")) {

	print LWRITE $last_ts_big;
	close(LWRITE);
	print "UPDATED TRIGGER to $last_ts_big\n";

} else {
	print "ooops, cannot write to $named_lastchange";	

}


# clean directory and files
# system("rm $dns_entries_path/*.*");


# create empty named.conf

open (CONFIG, ">$named_conf") || die "can't write to $named_conf";
print CONFIG "#\n# named.conf - generated on $date\n\#\n\n";
close CONFIG;


# load each domain entry

#mysql> show fields from dns_domains;
#+---------------+------------------------+------+-----+---------------------+-------+
#| Field         | Type                   | Null | Key | Default             | Extra |
#+---------------+------------------------+------+-----+---------------------+-------+
#| domain        | varchar(50)            |      | PRI |                     |       |
#| type          | set('primary','slave') |      |     |                     |       |
#| host_id       | varchar(30)            | YES  |     | NULL                |       |
#| owner_id      | int(11)                | YES  |     | NULL                |       |
#| creation_date | datetime               |      |     | 0000-00-00 00:00:00 |       |
#| timestamp     | timestamp(14)          | YES  |     | NULL                |       |
#+---------------+------------------------+------+-----+---------------------+-------+

$domain_query = $db->prepare("select domain,type,host_id,owner_id from $dns_domains");
$domain_query->execute or die "domain query error"; 
$dcount = 0;


while (($domain,$type,$host_id,$owner_id) = $domain_query->fetchrow_array) {

  print "[" . $dcount++ . "] $domain - $type - $host_id - $owner_id\n";
  if ($host_id) { 
    $primary_server = &get_host($host_id,1);
    print "host id -> " . &get_host($host_id,0) . " (" . &get_host($host_id,1) . ")\n"; 
  } 


  if ($type eq "primary") {

    # findout soa
    $domain_serial = &get_var("soa_serial",$domain); 

    $last_tsd = $db->prepare("select ts from $dns_entries where domain LIKE '$domain' AND var_name NOT LIKE 'soa_serial' order by ts desc limit 0,1");
    $last_tsd->execute or die "ts query error"; 
    $last_tsd = substr(($last_tsd->fetchrow_array)[0],0,8);
    print "last change $domain : $last_tsd\n";

    # keep only largest one
    if ($last_tsd < $last_ts) { $last_tsd = $last_tsd; }

    # upgrade/increment serial : 1. if something changed in dns_hosts
    #                            2. if something changed in dns_entries for the domain
    
    if (substr($domain_serial,0,8) == $last_tsd)
      { 
	$domain_serial++;
 	&update_serial($domain, $domain_serial);
      } 
    elsif (substr($domain_serial,0,8) < $last_tsd) 
      {
	$domain_serial = $last_tsd . "00";
	&update_serial($domain, $domain_serial);
      }
    

    # generate zone file   &check_name(&get_host(       ,0))
    
    open (ZONE, ">$dns_entries_path/$domain") || die "can't write to $dns_entries_path/$domain";
    print ZONE "\$ORIGIN $domain.\n";       
    print ZONE "\$TTL " . &get_var("soa_ttl",$domain) . "\n\n";       
    print ZONE "; entry generated by odns.pl on $date - $domain\n\n";
    print ZONE "\@\tIN\tSOA\t" . &check_name(&get_host(&get_var("soa_ns1",$domain),0)) . "\t" ;

    if (&check_name(&get_var("soa_admin",$domain))) {
    	print ZONE &check_name(&get_var("soa_admin",$domain)) . " (\n";
    } else {
   	print ZONE &check_name($default_dns_admin) . " (\n";

    }
    print ZONE "\t\t\t$domain_serial\t ; Serial\n";
    print ZONE "\t\t\t" .  &get_var("soa_refresh",$domain) . "\t\t ; Refresh\n";
    print ZONE "\t\t\t" .  &get_var("soa_retry",$domain) . "\t\t ; Retry\n";
    print ZONE "\t\t\t" .  &get_var("soa_expire",$domain) . "\t\t ; Expire\n";
    print ZONE "\t\t\t" .  &get_var("soa_ttl",$domain) . "\t)\t ; Minimum TTL\n";
    print ZONE "\n";
    print ZONE ";\n";
    print ZONE "; Name Servers\n";
    print ZONE ";\n";
    print ZONE "$domain.\tIN\tNS\t" . &check_name(&get_host(&get_var("soa_ns1",$domain),0)) . "\n";
    print ZONE "$domain.\tIN\tNS\t" . &check_name(&get_host(&get_var("soa_ns2",$domain),0)) . "\n";
    if (&get_var("soa_ns3",$domain)) {
      print ZONE "$domain.\tIN\tNS\t" . &check_name(&get_host(&get_var("soa_ns3",$domain),0)) . "\n";
    }
    if (&get_var("soa_ns4",$domain)) {
      print ZONE "$domain.\tIN\tNS\t" . &check_name(&get_host(&get_var("soa_ns4",$domain),0)) . "\n";
    }
    
    print ZONE "\n";
    print ZONE ";\n";
    print ZONE "; MX entries (Mail Servers)\n";
    print ZONE ";\n";

    # all other entries (alias), which aren't beginning with "soa_" 
    
    # first, the mx stuff
    
    $other_query = $db->prepare("SELECT var_name,host_id,var_content,mx_pref FROM $dns_entries WHERE domain LIKE '$domain' AND var_name NOT LIKE 'soa_%' AND entry_type LIKE 'mx' ORDER BY var_name");
    $other_query->execute or die "other query (non_soa) error"; 
    
    while (($ovar_name,$ohost_id,$ovar_content,$omx_pref) = $other_query->fetchrow_array) {

      if ($ovar_content) {
	$out =  &check_name($ovar_content);
      } elsif ($ohost_id) {
	$out = &check_name(&get_host($ohost_id,1));
      }
      
      print ZONE &check_name($ovar_name) . "\t\tIN\tMX $omx_pref\t";
      
      print ZONE "$out\n";
    } 
    
    print ZONE "\n";
    print ZONE ";\n";
    print ZONE "; A/CNAME entries \n";
    print ZONE ";\n";
    
    # then, the a/cname stuff
    
    $other_query2 = $db->prepare("SELECT var_name,host_id,var_content FROM $dns_entries WHERE domain LIKE '$domain' AND var_name NOT LIKE 'soa_%' AND entry_type LIKE 'a_cname' ORDER BY var_name");
    $other_query2->execute or die "other query (non_soa) error"; 
    
    while (($ovar_name,$ohost_id,$ovar_content) = $other_query2->fetchrow_array) {

      if ($ovar_content) {
	$out =  &check_name($ovar_content);
      } elsif ($ohost_id) {
	$out = &check_name(&get_host($ohost_id,1));
      }
      
      print ZONE &check_name($ovar_name) . "\t\tIN\t";
      
      if ($out =~ /\d*\.\d*\.\d*\.\d*/) {
	print ZONE "A\t$out\n";
      } else {
        print ZONE "CNAME\t$out\n";
      }     
    } 
    
    
    close ZONE;
    
  }

  # add entry in named.conf
  
  open (CONFIG, ">>$named_conf") || die "can't append to $named_conf";
  
  if ($type eq "primary") {
    # primary
    
    print CONFIG "\n### primary - $domain - $dns_entries_path/$domain\n\n";
    print CONFIG "zone \"$domain\" {\n";
    print CONFIG "\ttype master;\n";
    print CONFIG "\tfile \"$dns_entries_path/$domain\";\n";
    print CONFIG "};\n\n";

  } else {
    # slave
    
    print CONFIG "\n### slave - $domain - $host_id - $primary_server\n\n";
    print CONFIG "zone \"$domain\" {\n";
    print CONFIG "\ttype slave;\n";
    print CONFIG "\tmasters { $primary_server; };\n";
    print CONFIG "\tallow-update { $primary_server; };\n";
    print CONFIG "\tfile \"$dns_entries_path/slave.$domain\";\n";
    print CONFIG "};\n\n";


  }
  
  close CONFIG;
  
  
} # foreach (@domain = $domains_query->fetchrow_array)

# restart dns

system("$cmd_ndc reload");

print "</pre>\n\n";
exit(0);

#############################################################################################
#
# "resolve" host_id to : - as far as possible (IP) if $get_ip = 1
#                        - just the next if $get_ip = 0


#mysql> show fields from dns_hosts;
#+---------------+---------------+------+-----+---------------------+-------+
#| Field         | Type          | Null | Key | Default             | Extra |
#+---------------+---------------+------+-----+---------------------+-------+
#| host_id       | varchar(30)   |      | PRI |                     |       |
#| host          | varchar(30)   |      |     |                     |       |
#| creation_date | datetime      |      |     | 0000-00-00 00:00:00 |       |
#| ts            | timestamp(14) | YES  |     | NULL                |       |
#+---------------+---------------+------+-----+---------------------+-------+

sub get_host {
  
  my $host_id = $_[0];
  my $get_ip = $_[1];

  $get_host_query = $db->prepare("SELECT host FROM $dns_hosts WHERE host_id LIKE '$host_id'");
  $get_host_query->execute or die "host query error";
  
  if ($get_host_query->rows) {
    
    $host = ($get_host_query->fetchrow_array)[0];

    if ($host =~ /\d*\.\d*\.\d*\.\d*/ || !$get_ip) {
     return $host; 
    } else {
      return &get_host($host,$get_ip);
    }
  } else {
# dirty hack, mais qui semble fonctionner... s'il y a pas de traduction trouvee
# dans dns_hosts, revoyer le hostname donne en argument --> ok pour les CNAME
# donnes dans des var_content...

#    return 0;
    return $host_id;
  }
}

#############################################################################################
#
# return variable_contents or host_id
#

#mysql> show fields from dns_entries;
#+---------------+---------------+------+-----+---------------------+-------+
#| Field         | Type          | Null | Key | Default             | Extra |
#+---------------+---------------+------+-----+---------------------+-------+
#| domain        | varchar(50)   |      | MUL |                     |       |
#| var_name      | varchar(30)   |      |     |                     |       |
#| host_id       | varchar(30)   | YES  |     | NULL                |       |
#| var_content   | varchar(30)   | YES  |     | NULL                |       |
#| creation_date | datetime      |      |     | 0000-00-00 00:00:00 |       |
#| ts            | timestamp(14) | YES  |     | NULL                |       |
#+---------------+---------------+------+-----+---------------------+-------+


sub get_var {
  
  my $var_name = $_[0];
  my $domain = $_[1];
  
  $query = $db->prepare("SELECT host_id,var_content FROM $dns_entries WHERE var_name LIKE '$var_name' AND domain LIKE '$domain'");
  $query->execute or die "var query error";
 
  if ($query->rows) {
    ($my_host_id,$my_var_content) = $query->fetchrow_array;

    if ($my_var_content) {
      return $my_var_content;
    } elsif ($my_host_id) {
      return $my_host_id;
    } else { 
      return 0;
    }
    
  } else {
    return 0;
  }
}

#############################################################################################
#
# add a "." at the end of hostname if necessary
# and transform "@" -> "." (for the admin email)
# 
# bug: only hosts with no "." won't get a "." at the end :
#      may not be exactely what we want.

sub check_name {

  my $my_host = $_[0];
  my $my_domain = $domain;   # global

  if ($my_host =~ /\@/) { 
    $my_host =~ s/\@/\./g;
  }
  
  if ($my_host =~ /\d*\.\d*\.\d*\.\d*/) {
    return $my_host; 
  } elsif ($my_host eq $domain) {
    return "$my_host.";
  } elsif (($my_host =~ /^.*\.com$/) || ($my_host =~ /^.*\.mil$/) || ($my_host =~ /^.*\.net$/) || 
	    ($my_host =~ /^.*\.org$/) || ($my_host =~ /^.*\.\w\w$/)) {
    return "$my_host.";
  } else {
    return $my_host;
  }
  
}

#############################################################################################
#
# save new serial
# 

sub update_serial {

  my $my_domain = $_[0];
  my $my_serial = $_[1];
  
  $db->do("update $dns_entries SET var_content='$my_serial' WHERE domain LIKE '$domain' AND var_name LIKE 'soa_serial'") || die "update problem : $DBI::errstr";
  
}

#############################################################################################
