<?php


/*
        ----
        oDns  -  A php4/perl/mysql frontend for the BIND name server 
        ----

        * Copyright (C) 2000  Olivier Mueller <om@omnis.ch>

        $Id: odns_domain_form.php,v 1.3 2000/08/17 22:14:25 swix Exp $
        $Source: /cvsroot/oDns/odns/odns_domain_form.php,v $

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.
  
        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

function display_dns_form($domain, $action) { 

		global $conn, $caller;
		// caller = needed by useradmin to come back to the right place after use

		include("config.php");


		// initialize empty arrays
		
		
			$A_SOA_entries_var[""] = "";			
			$A_SOA_entries_host[""] = "";			
			$A_CNA_entries_var[""] = "";			
			$A_CNA_entries_host[""] = "";			
			$A_MX_entries_host[""] = "";
			$A_MX_entries_var[""] = "";


		// load data

			$A_hosts = load_data_array($tb_dns_hosts, "host_id", "host", "");
			$A_contacts = load_data_array($tb_dns_contacts, "contact_name", "contact_name", "");

		if ($action == "new" || $action == "edit") {

			if ($action == "new") {
				print "<h2>New zone creation using <b>$domain</b> as template</h2>";
			} else {
				print "<h2>Zone edition for <b>$domain</b></h2>";
			}

			$entry_owner_id = load_data_single($tb_dns_domains, "owner_id", "domain", "WHERE domain LIKE '$domain'");
		    // for soa
			$A_SOA_entries_host = load_data_array($tb_dns_entries, "var_name", "host_id", "WHERE host_id NOT LIKE '' AND domain LIKE '$domain' AND entry_type LIKE 'soa'");
			$A_SOA_entries_var = load_data_array($tb_dns_entries, "var_name", "var_content", "WHERE var_content NOT LIKE '' AND domain LIKE '$domain' AND entry_type LIKE 'soa'");
		    // for a/cnames (incl. www)
			$A_CNA_entries_host = load_data_array($tb_dns_entries, "var_name", "host_id", "WHERE host_id NOT LIKE '' AND domain LIKE '$domain' AND entry_type LIKE 'a_cname'");
			$A_CNA_entries_var = load_data_array($tb_dns_entries, "var_name", "var_content", "WHERE var_content NOT LIKE '' AND domain LIKE '$domain' AND entry_type LIKE 'a_cname'");
		    // for mx
			$A_MX_entries_host = load_data_array($tb_dns_entries, "CONCAT(mx_pref,'_',var_name)", "host_id", "WHERE host_id NOT LIKE '' AND domain LIKE '$domain' AND entry_type LIKE 'mx' ORDER BY var_name,mx_pref",1);
			$A_MX_entries_var = load_data_array($tb_dns_entries, "CONCAT(mx_pref,'_',var_name)", "var_content", "WHERE var_content NOT LIKE '' AND domain LIKE '$domain' AND entry_type LIKE 'mx' ORDER BY var_name,mx_pref",1);

		} else {

			print "<h2>New zone creation</h2>";

			// if action = "new_blank" -> add 3 standard items

			$A_CNA_entries_var["ftp"] = "";
			$A_CNA_entries_var["mail"] = "";
			$A_CNA_entries_var["pop3"] = "";
			$A_CNA_entries_var["pop"] = "";
			$A_CNA_entries_var["imap"] = "";
		}


		// print form

		print "<form action=\"$url_main\" method=\"POST\">";
		print "<table bgcolor=\"lightblue\" border=\"0\" cellpadding=\"3\">";   

		//
		// DOMAIN
		//

		if ($action == "new" || $action == "new_blank") { 
			print "<tr><td width=\"100%\" colspan=\"3\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
			print "<b>New Domain Registration</b></font></td></tr>";
			print "<tr><td>Domain:</td>";
			print "<td colspan=2><font size=\"-1\"><input type=\"text\" size=\"30\" name=\"domain\"></font></td>";	
			$topdomain = "domain.ext";

		} else { 
			print "<tr><td width=\"100%\" colspan=\"3\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
			print "<b>Primary for <i> $domain </i></b></font></td></tr>";
			print "<tr>"; 
			print "<td>Last Edited</td>";
			print "<td colspan=\"2\"><b>" . load_data_single($tb_dns_domains, "timestamp", "domain", "WHERE domain LIKE '$domain'");
			print  "</b></font></td>";
			print "</tr>";
			print "<tr><td>Domain:</td>";
			print "<td colspan=2><b>$domain</B>";
			print "<input type=\"hidden\" name=\"entry_owner_id\" value=\"$entry_owner_id\">";
			print "<input type=\"hidden\" name=\"id\" value=\"" .
				base64_encode($domain) . "\"></td>";	
			$topdomain = $domain;
		}
		print "</tr>";


		//
		// ADMINISTRATIVE INFORMATION 
		//



		print "<tr><td colspan=\"2\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
		print "<b>Administrative</b></font></td>";
		print "<td bgcolor=\"#000000\" align=\"right\"><font size=\"3\" color=\"#FFFFFF\">";
		print "<b><a href=\"$url_main?action=New+Contact\"><font color=\"#FFFFFF\">[add contact]</font></a></b></font></td></tr>";

		display_item_1("Administrative Contact", "soa_nic_adm", $A_SOA_entries_var, $A_contacts);
		display_item_1("Billing Contact", "soa_nic_bil", $A_SOA_entries_var, $A_contacts);
		display_item_1("Technical Contact", "soa_nic_tec", $A_SOA_entries_var, $A_contacts);


		//
		// SOA
		//

		$sel_refresh["DEFAULT_VALUE"] = "10800";
		$sel_refresh["600"] = "10 Minutes (600)";
		$sel_refresh["1200"] = "20 Minutes (1'200)";
		$sel_refresh["1800"] = "30 Minutes (1'800)";
		$sel_refresh["3600"] = "1 Hour (3'600)";
		$sel_refresh["10800"] = "3 Hours (10'800)";
		$sel_refresh["43200"] = "12 Hours (43'200)";
		$sel_refresh["86400"] = "1 Day (86'400)";
	
		$sel_expire["DEFAULT_VALUE"] = "604800";
		$sel_expire["600"] = "10 Minutes (600)";
		$sel_expire["1200"] = "20 Minutes (1'200)";
		$sel_expire["1800"] = "30 Minutes (1'800)";
		$sel_expire["3600"] = "1 Hour (3'600)";
		$sel_expire["10800"] = "3 Hours (10'800)";
		$sel_expire["43200"] = "12 Hours (43'200)";
		$sel_expire["86400"] = "1 Day (86'400)";
		$sel_expire["604800"] = "1 Week (604'800)";
		$sel_expire["2592000"] = "1 Month (2'592'000)";

		$sel_retry["DEFAULT_VALUE"] = "3600";
		$sel_retry["600"] = "10 Minutes (600)";
		$sel_retry["1200"] = "20 Minutes (1'200)";
		$sel_retry["1800"] = "30 Minutes (1'800)";
		$sel_retry["3600"] = "1 Hour (3'600)";
		$sel_retry["10800"] = "3 Hours (10'800)";
		$sel_retry["43200"] = "12 Hours (43'200)";
		$sel_retry["86400"] = "1 Day (86'400)";

		$sel_ttl["DEFAULT_VALUE"] = "43200";
		$sel_ttl["600"] = "10 Minutes (600)";
		$sel_ttl["1200"] = "20 Minutes (1'200)";
		$sel_ttl["1800"] = "30 Minutes (1'800)";
		$sel_ttl["3600"] = "1 Hour (3'600)";
		$sel_ttl["10800"] = "3 Hours (10'800)";
		$sel_ttl["43200"] = "12 Hours (43'200)";
		$sel_ttl["86400"] = "1 Day (86'400)";

		$today = date("Ymd00");
		if ($A_SOA_entries_var["soa_serial"] < $today) { $A_SOA_entries_var["soa_serial"] = $today; }
			else { $A_SOA_entries_var["soa_serial"] = $A_SOA_entries_var["soa_serial"] + 1; }

		print "<tr><td width=\"100%\" colspan=\"3\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
		print "<b>SOA Data</b></font></td></tr>";
  

		print "<tr><td>Serial</td>";
		print "<td><B>" . $A_SOA_entries_var["soa_serial"] . "</B>&nbsp;";
		print "<input type=\"hidden\" name=\"soa_serial\" value=\"" . $A_SOA_entries_var["soa_serial"] . "\"></td>";
		print "<td>(automaticaly updated)</td></tr>";
		print "<tr><td>Refresh</td>";
		print "<td colspan=2>";
		select_box($sel_refresh, "soa_refresh", $A_SOA_entries_var["soa_refresh"], 0);
		print "</td>";
		print "</tr>";
		print "<tr><td>Retry</td>";
		print "<td colspan=2>";
		select_box($sel_retry, "soa_retry", $A_SOA_entries_var["soa_retry"], 0);
		print "</td>";
		print "</tr>";
		print "<tr><td>Expire</td>";
		print "<td colspan=2>";
		select_box($sel_expire, "soa_expire", $A_SOA_entries_var["soa_expire"], 0);
		print "</td>";
		print "</tr>";
		print "<tr><td>Minimum Cache</td>";
		print "<td colspan=2>";
		select_box($sel_ttl, "soa_ttl", $A_SOA_entries_var["soa_ttl"], 0);
		print "</td>";
		print "</tr>";

		//
		// NAME Servers
		//

		print "<tr><td colspan=\"2\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
		print "<b>Name Servers</b></font></td>";
		print "<td bgcolor=\"#000000\" align=\"right\"><font size=\"3\" color=\"#FFFFFF\">";
		print "<b><a href=\"$url_main?action=New+Host\"><font color=\"#FFFFFF\">[add host]</font></a></b></font></td></tr>";


		display_item_2("Name Server 1", "soa_ns1", $A_SOA_entries_var, $A_SOA_entries_host, $A_hosts);
		display_item_2("Name Server 2", "soa_ns2", $A_SOA_entries_var, $A_SOA_entries_host, $A_hosts);
		display_item_2("Name Server 3", "soa_ns3", $A_SOA_entries_var, $A_SOA_entries_host, $A_hosts);

		//
		// MX Records
		//

		print "<tr><td width=\"100%\" colspan=\"3\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
		print "<b>MX Records</b></font></td></tr>";

		// outdated...
		// display_item_2("Primary MX", "soa_mx1", $A_SOA_entries_var, $A_SOA_entries_host, $A_hosts);
		// display_item_2("Backup MX", "soa_mx2", $A_SOA_entries_var, $A_SOA_entries_host, $A_hosts);


		// for the main domains MX's
		
		reset($A_MX_entries_host);
    		while(list ($int,$tmp) = each ($A_MX_entries_host) ) {

		    if (preg_match("/^(\d+)_($domain)$/", $int, $parts)) {
	
			display_item_mx($domain, $int, $A_MX_entries_var, $A_MX_entries_host, $A_hosts, $topdomain, $parts[1], 1);
		    }
		}

		reset($A_MX_entries_var);
		while(list ($int,$tmp) = each ($A_MX_entries_var) ) {
	    
		    if (preg_match("/^(\d+)_($domain)$/", $int, $parts)) {
			
			display_item_mx($domain, $int, $A_MX_entries_var, $A_MX_entries_host, $A_hosts, $topdomain, $parts[1], 1);
		    }
		}

		for ($j=1; $j < 3; $j++) {
    		    display_item_mx("ZONEDOMAIN", "new$j", $A_MX_entries_var, $A_MX_entries_host, $A_hosts, $topdomain, $MX_prefs, 1);
		}

		// for subdomain MX's


		reset($A_MX_entries_host);
		while(list ($int,$tmp) = each ($A_MX_entries_host) ) {

		    if (preg_match("/^(\d+)_(.*)$/", $int, $parts) && $int) {
    			if ($parts[2] != $domain) {
			    display_item_mx($parts[2], $int, $A_MX_entries_var, $A_MX_entries_host, $A_hosts, $topdomain, $parts[1], 0);
			}
		    }
		}

		reset($A_MX_entries_var);
		while(list ($int,$tmp) = each ($A_MX_entries_var) ) {

		    if (preg_match("/^(\d+)_(.*)$/", $int, $parts) && $int) {
			if ($parts[2] != $domain) {
   			    display_item_mx($parts[2], $int, $A_MX_entries_var, $A_MX_entries_host, $A_hosts, $topdomain, $parts[1], 0);
			}
		    }
		}


		for ($j=5; $j < 7; $j++) {
    		    display_item_mx("", "new$j", $A_MX_entries_var, $A_MX_entries_host, $A_hosts, $topdomain, $MX_prefs, 0);
		}


		//
		// Web Server
		//

		print "<tr><td width=\"100%\" colspan=\"3\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
		print "<b>Web Server</b></font></td></tr>";

		display_item_2("Webserver", "www", $A_CNA_entries_var, $A_CNA_entries_host, $A_hosts);
		print "<input type=\"hidden\" name=\"label_a_cname_www\" value=\"www\">";
	
		if ($A_CNA_entries_var[$domain] || $A_CNA_entries_host[$domain] || $action == "new_blank") {
				$www_short_on = "checked";
		} else {
				$www_short_off = "checked";
		}
		
		print "<tr><td>Webserver (short)</td>";
		print "<td colspan=2><font size=\"-1\"><input type=\"radio\" name=\"www_short\" value=\"1\" $www_short_on> ";
		if ($domain) {
			print "make http://$domain act like http://www.$domain";
		} else {
			print "make http://domain.ext act like http://www.domain.ext";
		}
		print "<br><font size=\"-1\"><input type=\"radio\" name=\"www_short\" value=\"0\" $www_short_off> ";
		print "do nothing";
		print "</font></td></tr>";

		//
		// Other Records & CNAME
		//

		print "<tr><td width=\"100%\" colspan=\"3\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
		print "<b>A/CNAME Records</b></font></td></tr>";

		reset($A_CNA_entries_host);
		while(list ($int,$tmp) = each ($A_CNA_entries_host) ) {

			if ( !ereg("soa_", $int) && !($int == $domain) && !($int == "www")) {
							// only for non-soa fields and not domain.ext
							// to be able to set domain.ext to something else
							// than the webserver, remove '&& !($int == $domain)'
							// and say 'do nothing' on the www part
 
				display_item_3($int, $int, $A_CNA_entries_var, $A_CNA_entries_host, $A_hosts, $topdomain);
			}
		}

		reset($A_CNA_entries_var);
		while(list ($int,$tmp) = each ($A_CNA_entries_var) ) {

			if ( !ereg("soa_", $int) && !($int == $domain) && !($int == "www")) {	// only for non-soa fields
				display_item_3($int, $int, $A_CNA_entries_var, $A_CNA_entries_host, $A_hosts, $topdomain);
			}
		}
		
		for ($j=1; $j < 5; $j++) {
		display_item_3("", "new$j", $A_CNA_entries_var, $A_CNA_entries_host, $A_hosts, $topdomain);
		}

		// 
		// Submit / Reset Buttons
		// 		

		print "<tr><td width=\"100%\" colspan=\"3\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
		print "<b>Action</b></font></td></tr>";
	
		print "<tr><td>Please choose:</td>";
		print "<td align=\"center\"><input type=\"submit\" value=\"Save Zone\">";
		print "<input type=\"hidden\" name=\"action\" value=\"parse_primary_form\"></td>";
		print "<input type=\"hidden\" name=\"caller\" value=\"" . $caller . "\"></td>";
		print "<td align=\"center\"><input type=\"reset\" value=\"Reset Form\"></td></tr>";

		print "</table>";
		print "</form>";

}




function display_item_1($label, $name, &$A_entries_var, &$A_contacts) {

		print "<tr><td>$label</td>\n";
		print "<td colspan=2>\n";
		select_box($A_contacts, "var_$name", $A_entries_var["$name"], 2);
		print "\n</td>\n";
		print "</tr>\n\n";
}


function display_item_2($label, $name, &$A_entries_var, &$A_entries_host, &$A_hosts) {

		// global $A_entries_var, $A_entries_host, $A_hosts;  
		// -> doesn't work

		print "<tr><td>$label</td>";
				print "<td><font size=\"-1\"><input type=\"text\" name=\"var_$name\" size=\"20\" value=\"" . $A_entries_var[$name] . "\">";
		print "</font></td>";
		print "<td>";
		if ($A_entries_var[$name]) {
			select_box($A_hosts, "host_$name", "", 2);	
		} else {
			select_box($A_hosts, "host_$name", $A_entries_host[$name], 2);	
		}
		print "</td></tr>";
}



function display_item_3($label, $name, &$A_entries_var, &$A_entries_host, &$A_hosts, $topdomain, $labeldescr = "label_a_cname") {

		// allow editing the label (for CNAME / A records) or MX's

		// global $A_entries_var, $A_entries_host, $A_hosts;  
		// -> doesn't work

		print "<tr><td><font size=\"-1\"><input type=\"text\" name=\"" . $labeldescr . "_$name\" size=\"12\" value=\"" . $label . "\"></font>.$topdomain</td>";
		print "<td><font size=\"-1\"><input type=\"text\" name=\"var_$name\" size=\"20\" value=\"" . $A_entries_var[$name] . "\"></font></td>";
		print "<td>";
		if ($A_entries_var[$name]) {
			select_box($A_hosts, "host_$name", "", 2);	
		} else {
			select_box($A_hosts, "host_$name", $A_entries_host[$name], 2);	
		}
		print "</td></tr>";
}


function display_item_mx($label, $name, &$A_entries_var, &$A_entries_host, &$A_hosts, $topdomain, $MX_pref, $domain_mx) {

		// domain_mx : 1 if mx for the current domain, 0 otherwise (for subdomains, etc.)

		$mx_prefs["DEFAULT_VALUE"] = "10";

		// not very portable, but very practical: display the empty mx's with increasing
		// preferencies : 10, 20, 30.
		if ($name == "new2" || $name == "new6") { $mx_prefs["DEFAULT_VALUE"] = "20"; }
		if ($name == "new3" || $name == "new7") { $mx_prefs["DEFAULT_VALUE"] = "30"; }

		$mx_prefs["1"] = "1";
		$mx_prefs["2"] = "2";
		$mx_prefs["3"] = "3";
		$mx_prefs["10"] = "10";
		$mx_prefs["20"] = "20";
		$mx_prefs["30"] = "30";

		print "<tr><td><font size=\"-1\">";

		if ($domain_mx) {
		    print "<input type=\"hidden\" name=\"label_mx_$name\" value=\"$label\">MX for <b>$topdomain</b> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		} else {
		    print "<input type=\"text\" name=\"label_mx_$name\" size=\"12\" value=\"" . $label . "\"></font>.$topdomain &nbsp;";
		}
		select_box($mx_prefs, "mx_pref_$name", $MX_pref, 0);
		print "</td>";
		print "<td><font size=\"-1\"><input type=\"text\" name=\"mx_var_$name\" size=\"20\" value=\"" . $A_entries_var[$name] . "\"></font></td>";
		print "<td>";
		if ($A_entries_var[$name]) {
			select_box($A_hosts, "mx_host_$name", "", 2);	
		} else {
			select_box($A_hosts, "mx_host_$name", $A_entries_host[$name], 2);	
		}
		print "</td></tr>";
}




function select_box($array, $name, $selected, $mode) {

	// mode: 0 = use both side of array : $key -> content /$value -> display
	// mode. 2 = use only the keys.

	print "<font size=\"-1\"><select name=\"$name\">";
	print "<option value=\"\"> - </option>";

	// check if $selected value is in array 
	// if not -> show default entry

	$found = 0;
	reset($array);
	while(list ($int3,$tmp3) = each ($array) ) {
			if($int3 == $selected) { $found = 1; }
	}

	if (!$found) { $selected = $array["DEFAULT_VALUE"]; }


	// print select array

	reset($array);
	while(list ($int3,$tmp3) = each ($array) ) {

		if ($int3 == $array["DEFAULT_VALUE"]) {
			$high_left = " * "; $high_right = " * ";
		} else {
			$high_left = ""; $high_right = "";
		}

		if (!($int3 == "DEFAULT_VALUE")) {
	
			if ($mode == 0) {
				if ($int3 == "$selected") {
		        echo "<option value=\"$int3\" selected>" .$high_left . $tmp3 . $high_right . "</option>";
				} else {
		        echo "<option value=\"$int3\">" .$high_left . $tmp3 .  $high_right . "</option>";
				}
			}

			if ($mode == 2) {
				if ($int3 == "$selected") {
		        echo "\n<option value=\"$int3\" selected>" .$high_left . $int3 . $high_right . "</option>";
				} else {
		        echo "\n<option value=\"$int3\">" .$high_left . $int3 .  $high_right . "</option>";
				}
			}

		}
	}
	
	print "</select></font>";

}


?>
